MODULE WMDebugger;	(** AUTHOR "BohdanT"; November 25, 2014 *)

IMPORT
	SYSTEM, WMMessages, KernelLog, Kernel32, Machine, Reflection, Objects,
	Modules, WMComponents, WM := WMWindowManager, WMStandardComponents,
	Strings, WMGraphics, WMRectangles,
	Files, Commands,
	WMWindowManager,
	UTF8Strings,
	WMTextView:=WMTextView2, Texts, TextUtilities, WMEditors, Streams,
	WMTabComponents,
	BtDTraps, BtMenus, WMTrees, BtDbgPanel, WMComboBox,
	CompilerInterface, WMDiagnostics, BtDecoder;
CONST
	Trace = FALSE;
CONST
	DataLen = 1024;
	MaxNbrOfTabs = 100;
	MaxFrames = 128;(*possible is very long*)

	MaxString = 64;
	MaxArray = 8;
CONST
	AlignTop=WMComponents.AlignTop;
	AlignNone=WMComponents.AlignNone;
	AlignLeft=WMComponents.AlignLeft;
	AlignClient=WMComponents.AlignClient;
	AlignRight=WMComponents.AlignRight;
	AlignBottom=WMComponents.AlignBottom
CONST
(*Colors*)
 clBkgText =0BCE0E0FFH;
 clBkgTextCode = LONGINT(00C4FFE1FFH);
 clBkgTextActive = LONGINT(00FCAD96FFH);
 clBkgToolBar =  LONGINT(0D4D0C8FFH);
CONST
	dsBreak=0;dsBreakOnce=1;dsCode=2;dsCurPC=3;
	
	(*dbgState*)
	dbgRun=0;dbgStoped=0;dbgRestore=1;dbgTrace=2;dbgBreak=3;
CONST
	Name = "Fox";
	Description = "Oberon Compiler";
	FileExtension = "MOD"; (*! temporary *)

VAR
	beginstr:ARRAY 10 OF CHAR;		(*for search @body section in the textfile*)
	endinstr:ARRAY 10 OF CHAR;		
	beginstrutf:ARRAY 10 OF LONGINT;
	endinstrutf:ARRAY 10 OF LONGINT;
TYPE
	Variable = Reflection.Variable;
	PVariable = POINTER TO  RECORD
		adr: ADDRESS;
		type, size, n, tdadr: LONGINT
	END;
	Canvas = WMGraphics.Canvas;
	String = Strings.String;
	Filename = ARRAY 256 OF CHAR;

	(*Information about relation position in text and offset in binary module*)
	PosInfo = POINTER TO RECORD
		pos:LONGINT;
		pc:ADDRESS;
		BrkState:SET;
		next:PosInfo;
	END;

	(*ProcInfo describe procedure position information for step over *)
	ProcInfo = POINTER TO RECORD	
	
		name:ARRAY 255 OF CHAR;		(*Name of procedure*)
		posList:PosInfo;					(*Pointer to list of position information*)
		next:ProcInfo;						(*pointer to next procedure in the module*)
		startOfs,							(*first and last address in memory (TODO: need find RET in code and END proc in source and add additional information)*)
		lastOfs:ADDRESS;
		END;

	ModuleInfoArr = POINTER TO ARRAY OF PosInfo;
	
	ModuleInfo = OBJECT
	VAR
		name:ARRAY 80 OF CHAR;	(*Name of module*)
		procList:ProcInfo;				(*List of procedure*)
		nofmi:LONGINT;
		mi:ModuleInfoArr;
		mid:BtDecoder.ModuleInfo;
		mod:Modules.Module;
		saveCode:Modules.Bytes;
		state:LONGINT;
		PROCEDURE &Init*(*CONST textView : WMTextView.TextView*);
		BEGIN
(*			SELF.textView:=textView;*)
			NEW(mi, 8192);
		END Init;

		PROCEDURE Sort*;
			PROCEDURE ThreeSort( l, c, r: LONGINT );
			VAR sort: PosInfo;
			BEGIN
				IF mi[l].pos > mi[c].pos THEN sort := mi[l];  mi[l] := mi[c];  mi[c] := sort END;
				IF mi[l].pos > mi[r].pos THEN sort := mi[l];  mi[l] := mi[r];  mi[r] := sort END;
				IF mi[c].pos > mi[r].pos THEN sort := mi[c];  mi[c] := mi[r];  mi[r] := sort END
			END ThreeSort;

			PROCEDURE InsertionSort( l, r: LONGINT );
			VAR i, j: LONGINT;  sort: PosInfo;
			BEGIN
				FOR i := l + 1 TO r DO
					sort := mi[i];  j := i;
					WHILE (j > 0) & (mi[j - 1].pos > sort.pos) DO mi[j] := mi[j - 1];  DEC( j ) END;
					mi[j] := sort
				END
			END InsertionSort;

			PROCEDURE QuickSort( l, r: LONGINT );
			CONST short = 7;   (* Short vectors sort faster with insertion. *)
			VAR c, i, j: LONGINT;  sort, temp: PosInfo;
			BEGIN
				IF r - l > short THEN  (* quick sort *)
					c := (l + r) DIV 2;  ThreeSort( l, c, r );  sort := mi[r];  i := l - 1;  j := r;
					REPEAT
						REPEAT INC( i ) UNTIL mi[i].pos >= sort.pos;
						REPEAT DEC( j ) UNTIL mi[j].pos <= sort.pos;
						temp := mi[i];  mi[i] := mi[j];  mi[j] := temp
					UNTIL j < i;
					mi[j] := mi[i];  mi[i] := mi[r];  mi[r] := temp;  QuickSort( l, j );  QuickSort( i + 1, r )
				ELSIF r > l THEN InsertionSort( l, r )
				ELSE  (* Nothing to sort. *)
				END
			END QuickSort;

		BEGIN
			IF nofmi <= 1 THEN RETURN END;
			QuickSort( 0, nofmi - 1 );
		END Sort;

		PROCEDURE AddPos*(curPI:ProcInfo; pos,pc:ADDRESS);
		VAR h : PosInfo;
		BEGIN {EXCLUSIVE}
			NEW(h); h.next := curPI.posList; curPI.posList := h;h.BrkState:={}; (*Add to proc info*)
			h.pos:=pos;
			h.pc:=pc;

			IF nofmi = LEN(mi) THEN Grow END; (*Add to module info*)
			mi[nofmi] := h;
			INC(nofmi);

		END AddPos;

		PROCEDURE Grow;
		VAR new: ModuleInfoArr; i : LONGINT;
		BEGIN
			NEW(new, LEN(mi) * 2);
			FOR i := 0 TO nofmi - 1 DO new[i] := mi[i] END;
			mi := new
		END Grow;

		PROCEDURE DumpPos;
		VAR cur:ProcInfo;
		pl:PosInfo;
		BEGIN
			KernelLog.String("######################### "); KernelLog.Ln;
			cur:=procList;
			WHILE (cur#NIL)&(cur.posList#NIL)(*&(pos>cur.posList.pos)*) DO 
				pl:=cur.posList;
				WHILE (pl#NIL)(*pos>=pl.pos*) DO 
						KernelLog.String("pl.pos= "); KernelLog.Int(pl.pos,5);
						KernelLog.String(" pc= "); KernelLog.Int(pl.pc,5);  KernelLog.Ln;
					pl:=pl.next;
				END;
				cur:=cur.next;
			END;
			KernelLog.String("######################### "); KernelLog.Ln;
		END DumpPos;
		
		PROCEDURE AddProc*(CONST name:ARRAY OF CHAR):ProcInfo;
		VAR h : ProcInfo;
		BEGIN {EXCLUSIVE}
			NEW(h); h.next := procList; h.posList:=NIL; procList := h;
			COPY(name,h.name);
			RETURN h;
			
		END AddProc;
		
		PROCEDURE Find*(CONST name:ARRAY OF CHAR;adr:ADDRESS):LONGINT;
		VAR
			cur:ProcInfo;
			pi,pc:PosInfo;
		BEGIN
			cur:=procList;
			WHILE (cur#NIL)&(name#cur.name) DO cur:=cur.next; END;
			IF cur#NIL THEN
				pi:=cur.posList;
				pc:=pi;
				WHILE (pi#NIL)&(adr<pi.pc) DO pc:=pi; pi:=pi.next; END;
				IF pi#NIL THEN
					RETURN pi.pos
				ELSE
					RETURN -1;
				END
			ELSE
				RETURN -1;
			END;
		END Find;
		
		PROCEDURE FindPC*(CONST name:ARRAY OF CHAR;adr:ADDRESS):BOOLEAN;
		VAR
			cur:ProcInfo;
			pi,pc:PosInfo;
		BEGIN
			cur:=procList;
			WHILE (cur#NIL)&(name#cur.name) DO cur:=cur.next; END;
			IF cur#NIL THEN
				pi:=cur.posList;
				pc:=pi;
				WHILE (pi#NIL)&(adr#pi.pc) DO pc:=pi; pi:=pi.next; END;
				IF pi#NIL THEN
					RETURN TRUE
				ELSE
					RETURN FALSE;
				END
			ELSE
				RETURN FALSE;
			END;
		END FindPC;

		PROCEDURE FindProc*(CONST name:ARRAY OF CHAR;VAR pi:PosInfo):BOOLEAN;
		VAR cur:ProcInfo;
		BEGIN
			cur:=procList;
			WHILE (cur#NIL)&(name#cur.name) DO cur:=cur.next; END;
			IF cur#NIL THEN
				pi:=cur.posList;
				RETURN TRUE;
			END;
			RETURN FALSE;
		END FindProc;

		PROCEDURE FindPos(pos:LONGINT):PosInfo;
		VAR
		 i:LONGINT;
		 res:PosInfo;
		BEGIN
			ASSERT(nofmi>0);
			(*TODO: binary seach*)
			IF pos<mi[0].pos THEN RETURN NIL;END;
			i:=0;
			WHILE (i<nofmi)&(pos>mi[i].pos) DO INC(i);END;
		 	IF i>0 THEN DEC(i); END;
		 	RETURN mi[i];
		END FindPos;

		PROCEDURE FindPos2(pos:LONGINT):PosInfo;
		VAR
		 i:LONGINT;
		 res:PosInfo;
		BEGIN
			ASSERT(nofmi>0); (*Possible you use not midified FoxAMDBackend !!!*)
			(*TODO: binary seach*)
			i:=0;
			WHILE (i<nofmi)&(pos>mi[i].pos) DO INC(i);END;
		 	RETURN mi[i];
		END FindPos2;


		PROCEDURE FindPosInProc*(pos,len:LONGINT):BOOLEAN;
		VAR cur:ProcInfo;
		pl:PosInfo;
		BEGIN
			cur:=procList;
			WHILE (cur#NIL)&(cur.posList#NIL)(*&(pos>cur.posList.pos)*) DO 
				pl:=cur.posList;
				WHILE (pl#NIL)(*pos>=pl.pos*) DO 
					IF (pos<pl.pos)&((pos+len)>pl.pos) THEN
(*						KernelLog.Ln;
						KernelLog.String("pos= "); KernelLog.Int(pos,5); 
						KernelLog.String("pl.pos= "); KernelLog.Int(pl.pos,5);
						KernelLog.String(" len= "); KernelLog.Int(len,5); KernelLog.Ln;*)
						RETURN TRUE;
					END;
					pl:=pl.next;
				END;
				cur:=cur.next;
			END;
			RETURN FALSE;
		END FindPosInProc;
		
		PROCEDURE FindPCinProc(pc:LONGINT;VAR cur:ProcInfo;VAR pi:PosInfo):BOOLEAN;
		BEGIN
			cur:=procList;
			WHILE (cur#NIL)&((pc<cur.startOfs)OR(pc>cur.lastOfs)) DO cur:=cur.next END;
			IF cur=NIL THEN RETURN FALSE END;
			pi:=cur.posList;
			WHILE (pi#NIL)&(pi.pc#pc)DO pi:=pi.next END;
			RETURN pi#NIL;
		END FindPCinProc;
		
		PROCEDURE FindPCinText(pc:ADDRESS;VAR pos:LONGINT):BOOLEAN;
		VAR cur:ProcInfo;
		BEGIN
			cur:=procList;
			WHILE (cur#NIL)&(cur.posList#NIL) DO
			
			END;
		END FindPCinText;
		
	END ModuleInfo;

VAR
	imgBrk:ARRAY 4 OF WMGraphics.Image;
	activePI:PosInfo;
	activePr:ProcInfo;
	activeTab:LONGINT;
TYPE
	DebugView = OBJECT (WMTextView.TextView)
		VAR
			m:ModuleInfo;
		PROCEDURE RenderLine*(canvas : WMGraphics.Canvas; VAR l : WMTextView.LineInfo; linenr, top, llen : LONGINT);
		VAR
			saveColor:LONGINT;
			r:WMRectangles.Rectangle;
			linelength:LONGINT;
			fl:BOOLEAN;
			di:PosInfo;
			st:SET;
		BEGIN
			fl:=FALSE;
			saveColor:=lineNumberBgColor.Get();
(*			KernelLog.String("linenr= "); KernelLog.Int(linenr, 8); *)
			IF llen < 0 THEN
				linelength := layout.GetLineLength(linenr);
				(* hack for the bidi formatter *)
			ELSE
				linelength := llen
			END;
(*			KernelLog.String("pos= "); KernelLog.Int(l.pos,5); 
			KernelLog.String(" len= "); KernelLog.Int(linelength,5); KernelLog.Ln;
*)

(*			IF m.FindPosInProc(l.pos,linelength) THEN
				r:=borders.Get();
				canvas.Fill(WMRectangles.MakeRect(0, top, bounds.GetWidth() - r.r, top + l.height),clBkgTextCode, WMGraphics.ModeSrcOverDst);
				fl:=TRUE;
			END;
*)			
			di:=m.FindPos2(l.pos);
			IF di#NIL THEN
				WHILE (di#NIL)&(di.pos>=l.pos)&(di.pos<(l.pos+linelength)) DO
					st:=st+di.BrkState+{dsCode};
(*					KernelLog.String("di.pos= "); KernelLog.Int(di.pos,0); KernelLog.String(" ");KernelLog.Int(SYSTEM.VAL(LONGINT,di.BrkState),0); *)
					di:=di.next;
				END;
			END;

			IF (dsCode IN st)&(activePI#NIL) THEN
				IF (activePI.pos>=l.pos)&(activePI.pos<(l.pos+linelength)) THEN
					st:=st+{dsCurPC};
				END;
			END;
			IF dsCurPC IN st THEN
				canvas.Fill(WMRectangles.MakeRect(0, top, bounds.GetWidth() - r.r, top + l.height),clBkgTextActive, WMGraphics.ModeSrcOverDst);
				fl:=TRUE;
			ELSIF dsCode IN st THEN
				canvas.Fill(WMRectangles.MakeRect(0, top, bounds.GetWidth() - r.r, top + l.height),clBkgTextCode, WMGraphics.ModeSrcOverDst);
				fl:=TRUE;
			END;

			RenderLine^(canvas, l, linenr, top, llen);
			IF st#{} THEN
				IF (dsBreak IN st)&(dsCurPC IN st) THEN
					canvas.DrawImage(4, top, imgBrk[3], WMGraphics.ModeSrcOverDst);
				ELSIF (dsCurPC IN st) THEN
					canvas.DrawImage(4, top, imgBrk[2], WMGraphics.ModeSrcOverDst);
				ELSIF(dsBreak IN st)THEN
					canvas.DrawImage(4, top, imgBrk[1], WMGraphics.ModeSrcOverDst);
				ELSE
					canvas.DrawImage(4, top, imgBrk[0], WMGraphics.ModeSrcOverDst);
				END;
			END;
			lineNumberBgColor.Set(saveColor);

		END RenderLine;
	END DebugView;


	DbgPanel = OBJECT(WMComponents.VisualComponent)
	VAR
		dv : DebugView;
		cvtext : Texts.Text;

		filename : Filename; (* name of tab (filename without path *)
		module:ARRAY 256 OF CHAR;
		owner : Window;
		procInfo:ProcInfo;
		vScrollbar : WMStandardComponents.Scrollbar;

		PROCEDURE &InitPanel *(window: Window);
		VAR
			resizerH, resizerV: WMStandardComponents.Resizer;
			textViews : ARRAY 2 OF WMTextView.TextView;
			format, res: LONGINT;
		BEGIN
			Init;
			owner := window;
			SetNameAsString(StrDbgPanel);

			NEW(procInfo);

			(*Editor vScrollbar*)
			NEW(vScrollbar);
			vScrollbar.alignment.Set(AlignRight); 
			AddContent (vScrollbar);

			(* -- Editor Area *)
			NEW(dv); dv.alignment.Set(AlignClient); dv.showBorder.Set(TRUE);
(*			dv.tv.SetExtFocusHandler(EditorFocusHandler);
			editPanel.AddContent(dv);*)
			AddContent (dv);
(*			dv.macros.Add(WMMacros.Handle);*)
			dv.isMultiLine.Set(TRUE);
			dv.allowTextSelection.Set(FALSE);
			dv.wrapMode.Set(WMTextView.NoWrap);
			dv.SetScrollbars(NIL,vScrollbar);
			dv.showLineNumbers.Set(TRUE);
			
			NEW(cvtext);
			dv.SetText(cvtext);
			dv.clBgCurrentLine.Set(LONGINT(0FFFF0080H));
			dv.alwaysShowCursor.Set(TRUE);
			dv.highlighting.SetAOC("Oberon");
			
		END InitPanel;
		PROCEDURE DoCompile();
		VAR

			tw : TextUtilities.TextWriter; errors : BOOLEAN; type: LONGINT;
			positions : ARRAY 2 OF LONGINT;
			pc,options:ARRAY 25 OF CHAR;
		BEGIN

			options:="-b=AMD -f=42";
			pc:="";
			compiler.CompileText(cvtext, "", 0, pc, options, tw, diagnostics, errors);
			
		END DoCompile;

	END DbgPanel;



	Semaphore* = OBJECT
		VAR busy: BOOLEAN;

		PROCEDURE Acquire*;
		BEGIN {EXCLUSIVE}
			AWAIT(~busy);
			busy := TRUE
		END Acquire;

		PROCEDURE Release*;
		BEGIN {EXCLUSIVE}
			busy := FALSE
		END Release;

		PROCEDURE &Init*;
		BEGIN
			busy := FALSE
		END Init;

	END Semaphore;

	

	Window* = OBJECT (WMComponents.FormWindow)
	VAR
			menuPanel : BtMenus.MenuPanel;
			regPanel: BtDbgPanel.RegPanel;
			tabs : WMTabComponents.Tabs;
			pages: ARRAY MaxNbrOfTabs OF DbgPanel;
			tabList : ARRAY MaxNbrOfTabs OF WMTabComponents.Tab;
			currentPage : DbgPanel;
			currentPageNr : LONGINT;
			combo : WMComboBox.ComboBox;
			page,codepanel : WMStandardComponents.Panel;
			varpnl : BtDbgPanel.VariablesPanel;
			mempnl : BtDbgPanel.MemPanel;
			codepnl : BtDbgPanel.CodePanel;
			semaphore : Semaphore;
			dbgState : SET;
			toolbar : WMStandardComponents.Panel;
		PROCEDURE NewToolButton(caption:ARRAY OF CHAR;img:ARRAY OF CHAR);
		VAR tmp:WMStandardComponents.Button;
		BEGIN
			NEW(tmp);tmp.alignment.Set(WMComponents.AlignLeft);tmp.bounds.SetWidth(32);
			tmp.caption.Set(Strings.NewString(caption));
			toolbar.AddContent(tmp);
		END NewToolButton;

		PROCEDURE CreateForm () : WMComponents.VisualComponent;
		VAR
			panel : WMStandardComponents.Panel;
			workspace, workspaceL, workspaceR: WMStandardComponents.Panel;
			resizer: WMStandardComponents.Resizer;

		BEGIN
			NEW(semaphore);dbgState:={dbgRun};
			NEW (panel); panel.bounds.SetExtents (1000, 800); 
			panel.fillColor.Set(LONGINT(0FFFFFFFFH));
			(*Init Menu*)

			NEW(menuPanel);
			menuPanel.SetToolBar(toolbar);
			menuPanel.fillColor.Set(LONGINT(WMGraphics.White));
			menuPanel.bounds.SetHeight(20);
			menuPanel.alignment.Set(AlignTop);
			menuPanel.horizontal.Set(TRUE);
			menuPanel.openDirection.Set(BtMenus.OpenDownRight);
(*			menuPanel.SetMenu(menu, root);
			menuPanel.onSelect.Add(Selected);*)
			panel.AddContent(menuPanel);

			NEW(toolbar);
			toolbar.bounds.SetHeight(24);
			toolbar.alignment.Set(AlignTop);
			toolbar.fillColor.Set(clBkgToolBar);
(*			NewToolButton("Test","");*)
			menuPanel.SetToolBar(toolbar);
			panel.AddContent(toolbar);


			menuPanel.LoadFromXML("WMDebugger/WMDebugger.XML",SELF);
(*			NewToolButton("Test2","");*)

			NEW(combo);combo.bounds.SetExtents(300, 20);combo.alignment.Set(AlignLeft);
			toolbar.AddContent(combo);
			combo.onClick.Add(ComboClick);
			
			(*Left space of the debugger*)
			NEW (workspaceL); workspaceL.bounds.SetWidth(200);workspaceL.alignment.Set(AlignLeft);
			workspaceL.fillColor.Set(0FFFFFFFFH);

			NEW(varpnl);varpnl.alignment.Set(AlignClient);
			varpnl.trv.onClickNode.Add(ClickNode);
			workspaceL.AddContent(varpnl);

			NEW(resizer); resizer.alignment.Set(AlignRight);resizer.bounds.SetWidth(4); workspaceL.AddContent(resizer);
			panel.AddContent(workspaceL);


			(*Right space of the debugger*)
			NEW (workspaceR); workspaceR.bounds.SetWidth(200);workspaceR.alignment.Set(AlignRight);
			
			NEW(regPanel);regPanel.bounds.SetWidth(200);regPanel.alignment.Set(AlignClient);
			workspaceR.AddContent(regPanel);

			NEW(resizer); resizer.alignment.Set(AlignLeft);resizer.bounds.SetWidth(4); workspaceR.AddContent(resizer);
			panel.AddContent(workspaceR);

			
			NEW(mempnl);
			mempnl.bounds.SetHeight(200); 
			mempnl.alignment.Set(AlignBottom); 
			NEW(resizer); resizer.alignment.Set(AlignTop);resizer.bounds.SetHeight(2); mempnl.AddContent(resizer);

			panel.AddContent (mempnl);
			NEW(codepnl);
			codepnl.bounds.SetHeight(200); 
			codepnl.alignment.Set(AlignBottom); 
			NEW(resizer); resizer.alignment.Set(AlignTop);resizer.bounds.SetHeight(2); codepnl.AddContent(resizer);

			panel.AddContent (codepnl);
			
			(*Editor panel*)
			NEW(workspace);
			workspace.fillColor.Set (clBkgText);
			workspace.bounds.SetWidth(250); 
			workspace.alignment.Set(AlignClient); 
			panel.AddContent (workspace);
			

			imgBrk[0]:=WMGraphics.LoadImage("WMDebugger/WMDebugger.zip://Brk/NoBrk.png", TRUE);
			imgBrk[1]:=WMGraphics.LoadImage("WMDebugger/WMDebugger.zip://Brk/SetBrk.png", TRUE);
			imgBrk[2]:=WMGraphics.LoadImage("WMDebugger/WMDebugger.zip://Brk/OnNoBrk.png", TRUE);
			imgBrk[3]:=WMGraphics.LoadImage("WMDebugger/WMDebugger.zip://Brk/OnBrk.png", TRUE);



			(* -- Tabs for the PETPanels *)
			NEW(tabs); tabs.fillColor.Set(00000CCCCH); tabs.bounds.SetHeight(20); tabs.alignment.Set(AlignTop);
			tabs.lineHeight.Set(20);
			workspace.AddContent(tabs);			
			tabs.onSelectTab.Add(TabSelected);

			NEW(page); page.fillColor.Set(clBkgText); page.alignment.Set(AlignClient);
			workspace.AddContent(page);



			RETURN panel
		END CreateForm;

		PROCEDURE &New;
		VAR vc : WMComponents.VisualComponent;
		w,h:LONGINT;
		m:WM.WindowManager;
		BEGIN
			vc := CreateForm ();
			Init (vc.bounds.GetWidth (), vc.bounds.GetHeight (), FALSE);
			SetContent (vc);
			vc.AlignSubComponents;
			icon := WMGraphics.LoadImage("WMDebugger/WMDebugger.zip://Icon.png", TRUE);

			SetIcon(icon);

			WM.DefaultAddWindow (SELF);	
			SetTitle (Strings.NewString ("WMDebugger"));
(* 

			w:=vc.bounds.GetWidth ()+10;
			h:=vc.bounds.GetHeight ()+10;
			m:=WM.GetDefaultManager();
			m.lock.AcquireWrite;
			m.SetWindowSize(SELF, w,h);
			m.lock.ReleaseWrite
*)

(*			Resizing(w, h);
			vc.Invalidate;*)
		END New;

		PROCEDURE Close ;
		BEGIN

			Close^;
			winstance := NIL
		END Close;

		PROCEDURE ClickNode(sender, data : ANY);
		VAR
			d: ANY;
			tree:WMTrees.Tree;
		BEGIN
			IF (data # NIL) & (data IS WMTrees.TreeNode) THEN
				tree:=varpnl.trv.GetTree();
				tree.Acquire;
				d := tree.GetNodeData(data(WMTrees.TreeNode));
				tree.Release;
				IF d # NIL THEN
					IF d IS PVariable THEN 
						KernelLog.String("ds= ");  KernelLog.Hex(d(PVariable).adr,8); KernelLog.Ln; 
							mempnl.address.Set(d(PVariable).adr) 
					END;
				END;
			END;
		END ClickNode;
		PROCEDURE GetLocalVars(int: Kernel32.Context;mod:Modules.Module);
		VAR t: Objects.Process;
			tree:WMTrees.Tree;
			i:LONGINT;
			root, local, call, var:WMTrees.TreeNode;
				VAR refpos: LONGINT; base: ADDRESS; refs: Modules.Bytes;

			PROCEDURE NewObjectFile(refs: Modules.Bytes): BOOLEAN;
			BEGIN
				RETURN (refs # NIL) & (LEN(refs) >0) & (refs[0]=0FFX);
			END NewObjectFile;
			


			(* Display variables. *)
			PROCEDURE Variables(refs: Modules.Bytes; refpos: LONGINT; base: ADDRESS);
			VAR v: Variable;pv:PVariable; j, col: LONGINT; name: ARRAY 65 OF CHAR; etc: BOOLEAN;
				value : ARRAY 255 OF CHAR;
			CONST dense = FALSE;
				PROCEDURE GetVarVal();
				VAR
					st : Streams.StringWriter;
					col:LONGINT;
				BEGIN
					col:=0;
					IF ( v.type = 15) THEN
						(*KernelLog.String("v.adr= "); KernelLog.Hex(v.adr,8);  KernelLog.Ln;*)
						IF v.adr#NIL	THEN 
							NEW(st, 255); Reflection.WriteVar(st,v,col);st.Get(value);
						ELSE
							value:="(NIL)";
						END
					ELSE
						NEW(st, 255); Reflection.WriteVar(st,v,col);st.Get(value);
					END;
					
					IF Trace THEN KernelLog.String(value); END;
				END GetVarVal;

			BEGIN
				LOOP
					Reflection.NextVar(refs, refpos, base, name, v);
					IF name[0] = 0X THEN EXIT END;
					(*??? Ln before array (except string) 
					IF (col # 0 ) & (v.n > 1) & (v.type # 15) THEN	
						w.Ln; col := 0; Wait(w);
					END;
					*)
					(* write name *)
					IF Trace THEN KernelLog.Char("	"); KernelLog.String(name); KernelLog.Char("="); END;
					NEW(var);
					tree.AddChildNode(call,var);
					tree.SetNodeCaption(var, Strings.NewString(name));
					NEW(pv);
					pv.adr:=v.adr;
					tree.SetNodeData(var,pv);

					j := 0; WHILE name[j] # 0X DO INC(j) END;
		(*			INC(col, SepLen+1+j);*)
						(* write variable *)
					IF (v.adr >= -4) & (v.adr < 4096) THEN	(* must be NIL VAR parameter *)
						IF Trace THEN KernelLog.String("NIL ("); KernelLog.Hex(v.adr, -8); KernelLog.Char(")"); END;
						value:="NIL(TODO)";
					ELSE
						etc := FALSE;
		(*				IF v.type = 15 THEN
							IF v.n > MaxString THEN etc := TRUE; v.n := MaxString END
						ELSE
							IF v.n > MaxArray THEN etc := TRUE; v.n := MaxArray END
						END;*)
		(*!TODO				Reflection.WriteVar(w, v, col);	*)(* write value *)
						GetVarVal();
					END;
					Strings.Append(name,'=');
					tree.SetNodeCaption(var, Strings.ConcatToNew(name,value));

					tree.SetNodeState(var, {WMTrees.NodeExpanded});

					IF Trace THEN KernelLog.Ln; END;
				END;
			END Variables;
			(* Write the specified procedure name and returns parameters for use with NextVar and Variables. *)
			PROCEDURE WriteProc0( mod: Modules.Module; pc, fp: ADDRESS; VAR refs: Modules.Bytes;
					VAR refpos: LONGINT; VAR base: ADDRESS);
			VAR ch: CHAR; startpc: ADDRESS;
			pName:ARRAY 255 OF CHAR;
			i:LONGINT;
			BEGIN
				refpos := -1;
				IF mod = NIL THEN
					IF pc = 0 THEN KernelLog.String("NIL")
					ELSE
						KernelLog.String("Unknown PC="); KernelLog.Address(pc); KernelLog.Char("H")
					END;
					IF fp # -1 THEN
						KernelLog.String(" FP="); KernelLog.Address(fp); KernelLog.Char("H")
					END
				ELSE
					NEW(call);
					tree.AddChildNode(local, call);

					IF Trace THEN KernelLog.String(mod.name); END;
					IF ~NewObjectFile(mod.refs) THEN
						DEC(pc, ADDRESSOF(mod.code[0]));
					END;
					refs := mod.refs;
					IF (refs # NIL) & (LEN(refs) # 0) THEN
						refpos := BtDTraps.FindProc(refs, pc, startpc);
						IF refpos # -1 THEN
							IF Trace THEN KernelLog.Char("."); END;
							ch := refs[refpos]; INC(refpos);
							IF ch = "$" THEN base := mod.sb ELSE base := fp END;	(* for variables *)
							pName[0]:='.';i:=1;
							WHILE ch # 0X DO IF Trace THEN KernelLog.Char(ch); END; pName[i]:=ch; ch := refs[refpos]; INC(i); INC(refpos) END;
							(*KernelLog.Char(":"); KernelLog.Int(LONGINT(pc-startpc),1);*)
							tree.SetNodeCaption(call, Strings.ConcatToNew(mod.name,pName));
						END
					END;
					IF Trace THEN KernelLog.Ln; END;
		(*			KernelLog.String(" pc="); KernelLog.Int(LONGINT(pc),1); KernelLog.String(" ["); KernelLog.Address (pc); KernelLog.String("H]");
					KernelLog.String(" = "); KernelLog.Int(LONGINT(startpc),1);  KernelLog.String(" + "); KernelLog.Int(LONGINT(pc-startpc),1);
					KernelLog.String(" crc="); KernelLog.Hex(mod.crc,-8);*)
				END
			END WriteProc0;

			(* Display call trackback. *)
			PROCEDURE StackTraceBack( pc, bp: ADDRESS; stackhigh: ADDRESS; long, overflow: BOOLEAN);
			VAR count,refpos: LONGINT; stacklow: ADDRESS; base: ADDRESS; m: Modules.Module; refs: Modules.Bytes;
			BEGIN
				count := 0;	(* frame count *)
				stacklow := bp;
				REPEAT
					m := Modules.ThisModuleByAdr0(pc);
					IF ((m # NIL) OR (count = 0)) & (bp # 0) & (bp >= stacklow) & (bp <= stackhigh) THEN
						IF Machine.ValidHeapAddress( pc ) THEN
							WriteProc0(m, pc, bp, refs, refpos, base); (*Get Module.Procedure name*)
							IF long & (~overflow OR (count > 0)) THEN	(* show variables *)
								IF refpos # -1 THEN Variables(refs, refpos, base) END;
							END;
							tree.SetNodeState(call, {WMTrees.NodeExpanded});
						ELSE
							KernelLog.String( "Unknown external procedure, pc = " );  KernelLog.Hex( pc,0 );  KernelLog.Ln; 
						END;
						SYSTEM.GET(bp + SIZEOF(ADDRESS), pc);	(* return addr from stack *)
						SYSTEM.GET(bp, bp);	(* follow dynamic link *)
						INC(count)
					ELSE
						bp := 0
					END;
				UNTIL (bp = 0) OR (count = MaxFrames);
			END StackTraceBack;

		BEGIN
(*			WriteProc0(Modules.ThisModuleByAdr0(int.PC) , int.PC, int.BP, refs, refpos, base);KernelLog.Ln;
			IF refpos # -1 THEN Variables(refs, refpos, base) END;
*)
			tree:=varpnl.trv.GetTree();
			tree.Acquire;
			NEW(root);
			tree.SetNodeCaption(root, Strings.NewString("Variables"));
			tree.SetRoot(root);
			tree.InclNodeState(root, WMTrees.NodeAlwaysExpanded);
			
			NEW(local);
			tree.AddChildNode(root, local);
			tree.SetNodeCaption(local, Strings.NewString("Local Variables"));
			t := Objects.CurrentProcess();
			(*Local variables*)
			StackTraceBack( int.PC, int.BP, Objects.GetStackBottom(t), TRUE, FALSE);
			tree.SetNodeState(local, {WMTrees.NodeExpanded});
			
			(*Global variables for opened modules*)
			WHILE (pages[i]#NIL)&(i<MaxNbrOfTabs) DO 
				BtDTraps.InitVar(pages[i].dv.m.mod, refs, refpos, base);
				IF refpos # -1 THEN
					NEW(call);
					tree.AddChildNode(root, call);
					tree.SetNodeCaption(call, Strings.NewString(pages[i].dv.m.mod.name));
					Variables(refs, refpos, base);
					tree.SetNodeState(call, {WMTrees.NodeExpanded});
				END;
				INC(i) 
			END;
			
			tree.Release;

		END GetLocalVars;

		PROCEDURE ToFront*;
		VAR manager : WMWindowManager.WindowManager; 
		BEGIN
			manager := WMWindowManager.GetDefaultManager();
			manager.SetFocus(SELF);
			manager.ToFront(SELF)
		END ToFront;

		PROCEDURE DbgHandler( VAR int: Kernel32.Context;  VAR exc: Kernel32.ExceptionRecord;  VAR handled: BOOLEAN );
		VAR
			i:LONGINT;
			mod:Modules.Module;
			proc:ProcInfo;
			pi:PosInfo;
		BEGIN  (* interrupts off *)
			IF Trace THEN KernelLog.String("##**dbgState=");KernelLog.Bits(dbgState,0,8);KernelLog.String(" PC="); KernelLog.Hex(int.PC,0); KernelLog.Ln; END;
			IF dbgRestore IN dbgState THEN
				IF Trace THEN KernelLog.String("**Restore!**"); KernelLog.Ln; END;
				BtDTraps.brkPnt.ChgState(TRUE);
				EXCL(dbgState,dbgRestore);
				handled:=TRUE;
				IF dbgTrace IN dbgState THEN
					INCL(SYSTEM.VAL(SET,int.FLAGS),8);
				END;
			ELSIF dbgTrace IN dbgState THEN
				IF Trace THEN KernelLog.String("**trace!**"); KernelLog.Ln; END;
				mod := Modules.ThisModuleByAdr(int.PC);
				i:=0;
				WHILE (pages[i]#NIL)&(i<MaxNbrOfTabs)&(mod#pages[i].dv.m.mod) DO INC(i) END;
				IF (pages[i]#NIL)&(i#MaxNbrOfTabs) THEN
					IF Trace THEN KernelLog.String("Page Found!= ");  KernelLog.Ln; END;
					IF pages[i].dv.m.FindPCinProc(int.PC,proc,pi) THEN
								activePI:=pi;
								activePr:=proc;
								activeTab:=i;
								
								SelectTab(i);
								currentPage.dv.cursor.SetPosition(pi.pos+1);
								currentPage.dv.cursor.SetVisible(TRUE);
								regPanel.UpDate(int);
								
								EXCL(dbgState,dbgTrace);
								semaphore.busy:=TRUE;
								BtDTraps.brkPnt.ChgState(FALSE);
								GetLocalVars(int, mod);
								codepnl.StartNewOpcodes(
									currentPage.dv.m.mid.GetOpcodes(
										currentPage.dv.m.mid.FindProcedureFromPC(pi.pc-ADDRESSOF(mod.code[0]))),ADDRESSOF(mod.code[0]),pi.pc);
								ToFront;
								mempnl.Invalidate();
								semaphore.Acquire;
								activePI:=NIL;
								activePr:=NIL;
								pages[i].dv.Invalidate;
								handled:=TRUE;
(*								BtDTraps.brkPnt.ChgState(TRUE);*)
									INCL(SYSTEM.VAL(SET,int.FLAGS),8);
								IF ~(dbgTrace IN dbgState) THEN
									INCL(dbgState,dbgRestore);
								END;

					ELSE
								handled:=TRUE;
								INCL(SYSTEM.VAL(SET,int.FLAGS),8);
					END;
				ELSE
								handled:=TRUE;
								INCL(SYSTEM.VAL(SET,int.FLAGS),8);
				END;
			ELSIF dbgRun IN dbgState THEN
				activePI:=NIL;
				activePr:=NIL;
				
				IF Trace THEN KernelLog.String("**Break!**"); END;
				mod := Modules.ThisModuleByAdr(int.PC);
				WHILE (pages[i]#NIL)&(i<MaxNbrOfTabs)&(mod#pages[i].dv.m.mod) DO INC(i) END;
				
				IF (pages[i]#NIL)&(i#MaxNbrOfTabs)&(pages[i].dv.m.state=dbgBreak) THEN
					RestoreCode(pages[i].dv.m);
				END;
				
				BtDTraps.brkPnt.RemoveTmpBP();
				BtDTraps.brkPnt.ChgState(FALSE);

				IF (pages[i]#NIL)&(i#MaxNbrOfTabs) THEN
					IF Trace THEN
						KernelLog.String("Page Found!= ");  KernelLog.Ln;
					END;
					IF pages[i].dv.m.FindPCinProc(int.PC,proc,pi) THEN
								activePI:=pi;
								activePr:=proc;

								IF Trace THEN KernelLog.String("Pos = "); KernelLog.Int(pi.pos, 0); KernelLog.Ln; END;
								SelectTab(i);
								currentPage.dv.cursor.SetPosition(pi.pos+1);
								currentPage.dv.cursor.SetVisible(TRUE);
								regPanel.UpDate(int);

								semaphore.busy:=TRUE;
								GetLocalVars(int,mod);
								codepnl.StartNewOpcodes(
									currentPage.dv.m.mid.GetOpcodes(
										currentPage.dv.m.mid.FindProcedureFromPC(pi.pc-ADDRESSOF(mod.code[0]))),ADDRESSOF(mod.code[0]),pi.pc);
								ToFront;
								mempnl.Invalidate();
								semaphore.Acquire;
								activePI:=NIL;
								activePr:=NIL;
								pages[i].dv.Invalidate;
								handled:=TRUE;
								INCL(SYSTEM.VAL(SET,int.FLAGS),8);
								INCL(dbgState,dbgRestore);
					ELSE
						KernelLog.String("Hmm....= "); KernelLog.Ln; 
					END;

				END;
			END;

(*			WHILE pages[i]#NIL DO
			END;*)
		END DbgHandler;

		PROCEDURE onRun*(sender, data : ANY);
		BEGIN
			IF Trace THEN KernelLog.String("Run"); KernelLog.Ln;  END;
			IF activePr#NIL THEN 
				semaphore.Release;
			END;
		END onRun;
		
		PROCEDURE onGo*(sender, data : ANY);
		BEGIN
			IF Trace THEN KernelLog.String("Run"); KernelLog.Ln;  END;
			IF activePr#NIL THEN 
				semaphore.Release;
			END;
		END onGo;
		
		PROCEDURE Load(CONST filename : ARRAY OF CHAR);
		VAR
			text : Texts.Text; res : LONGINT;
			msg : ARRAY 512 OF CHAR;
			readonly : BOOLEAN;
			name, fullname, ext, ext2, entryName, path : Filename;
			syntaxHighlighterName : ARRAY 32 OF CHAR;
			file : Files.File;
			format: LONGINT;
			d1,t1,d2,t2:LONGINT;
			mdi:BtDecoder.ModuleInfoObjectFile;
		BEGIN
			DisableUpdate;
			IF Trace THEN
				KernelLog.Ln;
				KernelLog.String("Load module = "); KernelLog.String(filename); KernelLog.Ln;
			END;

			res := -1;
			NewTab; (* create a new Tab with an empty DbgPanel to Load into *)
			Files.SplitPath(filename, path, currentPage.filename);
			Files.SplitExtension(currentPage.filename,name,ext);
			
			Files.SplitExtension(currentPage.filename,name,ext);
			Files.SplitExtension(name,name,ext);
			IF Trace THEN
				KernelLog.String("Module prefix= "); KernelLog.String(name); KernelLog.Ln;
				KernelLog.String("Module ext= "); KernelLog.String(ext); KernelLog.Ln;
			END;
			IF ext#"" THEN name:=ext; END;
			IF Trace THEN
				KernelLog.String("Module name= "); KernelLog.String(name); KernelLog.Ln;
			END;
			currentPage.module:=name;
			currentPage.dv.firstLine.Set(0);
			currentPage.dv.cursor.SetPosition(0);
			currentPage.dv.SetFocus;
				TextUtilities.LoadAuto(currentPage.cvtext, filename, format, res);
				IF res#0 THEN
					KernelLog.String("ERROR: can't open "); KernelLog.String(filename); KernelLog.Ln;
					RETURN;
				END;

			file:=Files.Old(filename);
			file.GetDate(t1,d1);
			Files.JoinExtension(name,'Dpi',entryName);
			file:=Files.Old(entryName);
			IF file#NIL THEN (*file exists*)
				file.GetDate(t2,d2);
			ELSE
				d2:=0;t2:=0;
			END;
			IF (d1>d2)OR((d1=d2)&(t1>t2)) THEN
				IF Trace THEN
					KernelLog.String("d1= "); KernelLog.Int(d1, 0); KernelLog.String(" t1= "); KernelLog.Int(t1, 0); KernelLog.Ln; 
					KernelLog.String("d2= "); KernelLog.Int(d2, 0); KernelLog.String(" t2= "); KernelLog.Int(t2, 0); KernelLog.Ln; 

					KernelLog.String("Recompile module: "); KernelLog.String(filename); KernelLog.Ln;
				END;
				currentPage.DoCompile();
			END;
			
(*			LoadBP(entryName,currentPage.tvtext,currentPage.procInfo);*)
			LoadModulePosInfo(entryName, currentPage.dv.m,currentPage.cvtext);

			Files.JoinExtension(name, 'Obw', entryName);
			NEW(mdi, entryName);
			currentPage.dv.m.mid:=mdi;
			
			COPY(currentPage.filename, tabList[currentPageNr].caption^); tabs.Invalidate;
			KernelLog.String("tab= "); KernelLog.String(currentPage.filename); KernelLog.Ln;
			tabs.Invalidate;
			UpdatePages;
			EnableUpdate;
			form.Invalidate;
		END Load;


		PROCEDURE Handle(VAR m: WMMessages.Message);
		BEGIN
			IF m.msgType = WMMessages.MsgKey THEN
				IF ~menuPanel.HandleShortcut(CHR(m.x), m.flags, m.y) THEN
					Handle^(m);
				END;
			ELSE Handle^(m)
			END
		END Handle;
		
		PROCEDURE RestoreCode(m:ModuleInfo);
		VAR
			i:LONGINT;
			col:LONGINT;
		BEGIN
			col:=0;
			Machine.Acquire(Machine.Modules);
			FOR i := 0 TO LEN(m.mod.code)-1 DO 
				m.mod.code[i] := currentPage.dv.m.saveCode[i];
			END;
			currentPage.dv.m.saveCode:=NIL;
			Machine.Release(Machine.Modules);

			currentPage.dv.m.state:=0;
		END RestoreCode;
		
		
		PROCEDURE ComboClick(sender, data : ANY);
		VAR
			p:ProcInfo;
			pl:PosInfo;
			i:LONGINT;
			mod:Modules.Module;
		BEGIN
			IF (data#NIL)&(data IS ProcInfo) THEN
			
				p:=data(ProcInfo);
				pl:=p.posList;
				IF pl=NIL THEN RETURN END;
				
				WHILE pl.next#NIL DO pl:=pl.next END;

				mod := Modules.ThisModuleByAdr(pl.pc);(*!TODO: optimize!*)
				i:=0;
				WHILE (pages[i]#NIL)&(i<MaxNbrOfTabs)&(mod#pages[i].dv.m.mod) DO INC(i) END;
				IF (pages[i]#NIL)&(i#MaxNbrOfTabs) THEN
					SelectTab(i);
					currentPage.dv.cursor.SetPosition(pl.pos);
					currentPage.dv.cursor.SetVisible(TRUE);
				END;
				
			END;
		END ComboClick;
		
		
		PROCEDURE OnBreak*(sender, data : ANY);
		VAR
			position:LONGINT; di:PosInfo;
		VAR p, m: Modules.Module;  i: LONGINT;

		BEGIN
			KernelLog.String("!!!OnBreak!!! "); KernelLog.Ln; 
			IF activePr=NIL THEN
				IF currentPage.dv.m#NIL THEN
				
					m:=currentPage.dv.m.mod;
					currentPage.dv.m.state:=dbgBreak;
					NEW(currentPage.dv.m.saveCode,LEN(m.code));
					Machine.Acquire(Machine.Modules);

					FOR i := 0 TO LEN(m.code)-1 DO 
						currentPage.dv.m.saveCode[i]:=m.code[i];
						m.code[i] := 0CCX (*Putin=huylo - podvesil process*)
					END;
					KernelLog.String("Break setting ok! "); KernelLog.Ln; 
					Machine.Release(Machine.Modules);

				END;				;

(*				mod := Modules.ThisModuleByAdr( pc );  
					
				KernelLog.String( "Objects Break at adr: " ); KernelLog.Int( pc, 5 );  KernelLog.Ln;

					IF mod # NIL THEN
						KernelLog.String( "In module: " );  KernelLog.String( mod.name );KernelLog.Ln;
					END;*)
			END;
		END OnBreak;
		
		PROCEDURE ShowExecutionPoint*(sender, data : ANY);
		BEGIN
			IF Trace THEN KernelLog.String("!!!ShowExecutionPoint!!! "); KernelLog.Ln; END;
			IF activePI#NIL THEN
				SelectTab(activeTab);
				currentPage.dv.cursor.SetPosition(activePI.pos+1);
				currentPage.dv.cursor.SetVisible(TRUE);
			END;
		END ShowExecutionPoint;
		
		
		PROCEDURE OnRunToCoursor*(sender, data : ANY);
		VAR
			position:LONGINT;
			di:PosInfo;
		BEGIN
			IF Trace THEN KernelLog.String("!!!OnRunToCoursor!!! "); KernelLog.Ln; END;
			position := currentPage.dv.cursor.GetPosition()-1;(*TODO: correcting*)
			di:=currentPage.dv.m.FindPos2(position);
			IF di#NIL THEN
				BtDTraps.brkPnt.AddTmpBP(di.pc);
				semaphore.Release;
			END;
		END OnRunToCoursor;

		PROCEDURE OnStepInto*(sender, data : ANY);
		VAR
			pr:PosInfo;
		BEGIN
			IF Trace THEN KernelLog.String("!!!OnStepInto!!! "); KernelLog.Ln; END;
			IF activePr#NIL THEN 
				INCL(dbgState,dbgTrace);
				semaphore.Release;
			END;
		END OnStepInto;

		PROCEDURE OnStepOver*(sender, data : ANY);
		VAR
			pr:PosInfo;
		BEGIN
			IF Trace THEN KernelLog.String("!!!OnStepOver!!! "); KernelLog.Ln; END;
			IF activePr#NIL THEN 
				pr:=activePr.posList;
				IF pr#NIL THEN
					WHILE pr#NIL DO
						BtDTraps.brkPnt.AddTmpBP(pr.pc);
						pr:=pr.next;
					END;
					INCL(dbgState,dbgRun);
					semaphore.Release;
				END;
			END;
		END OnStepOver;

		PROCEDURE OnRunUntilReturn*(sender, data : ANY);
		VAR
			adr:ADDRESS;
		BEGIN
			IF Trace THEN KernelLog.String("!!!OnRunUntilReturn!! "); KernelLog.Ln; END;
			IF activePr#NIL THEN 
				BtDTraps.brkPnt.AddTmpBP(activePr.lastOfs);	
				INCL(dbgState,dbgRun);
				semaphore.Release;
			END;
		END OnRunUntilReturn;

		PROCEDURE OnToggleBP*(sender, data : ANY);
		VAR
		 di:PosInfo;

		 cmd,pos:ARRAY 18 OF CHAR;
		 adr:LONGINT;
		 res:LONGINT;
		 ln, lp, ll, cp:LONGINT;(*current line number, start position and coursor position*)
		BEGIN
			IF Trace THEN KernelLog.String("!!!ToggleBP!!! "); KernelLog.Ln; END;
		 
			IF currentPage=NIL THEN RETURN END;
			IF Trace THEN KernelLog.String("BP= "); KernelLog.Int(currentPage.dv.cursor.GetPosition(), 0);  END;
			cp:=currentPage.dv.cursor.GetPosition();
			ln:=currentPage.dv.layout.FindLineNrByPos(cp);
			lp:=currentPage.dv.layout.GetLineStartPos(ln);
			ll := currentPage.dv.layout.GetLineLength(ln);
			
			di:=currentPage.dv.m.FindPos2(lp);
			IF (di#NIL)&(di.pos>=lp)&(di.pos<(lp+ll)) THEN
				IF Trace THEN KernelLog.String("di= "); KernelLog.Int(di.pos, 0); END;
				di.BrkState:=di.BrkState/{dsBreak};
				IF dsBreak IN di.BrkState THEN
					BtDTraps.brkPnt.AddBP(di.pc);
				ELSE
					BtDTraps.brkPnt.RemoveBP(di.pc);

(*					BTDebuggerXmd.commander.ChangeBP(FALSE,di.code);*)
				END;
				currentPage.dv.Invalidate;
			END;


		END OnToggleBP;
		PROCEDURE CursorChanged;
(*		VAR
			position : LONGINT; pos : ARRAY 16 OF CHAR;
			posutf:ARRAY 16 OF LONGINT;
			di:DebugModuleT;
			idx:LONGINT;*)
		BEGIN
(*			curcodecur:=-1;
			position := currentPage.tv.cursor.GetPosition();
			di:=currentPage.debugModule.FindPos(currentPage.tv.cursor.GetPosition());
			IF (di#NIL)&(di#curdi) THEN
				Strings.IntToHexStr(di.code,8,pos);
				Strings.AppendChar(pos,":");
(*				KernelLog.String("ds="); KernelLog.String(pos); KernelLog.Ln;*)
				idx:=0;UTF8Strings.UTF8toUnicode(pos, posutf, idx);
				cvtext.AcquireRead;
				position:=TextUtilities.GenericPos(posutf, 0, cvtext, FALSE, FALSE);
				cv.cursor.SetPosition(position);
				cvtext.ReleaseRead;
				cv.cursor.SetVisible(TRUE);
(*				cv.SetFocus;*)
			END;
			curdi:=di;*)
		END CursorChanged;
		
		PROCEDURE NewTab;
		VAR pet : DbgPanel;
			i : LONGINT;
			found : BOOLEAN;
		BEGIN
			found := FALSE;
			NEW(pet, SELF); pet.alignment.Set(AlignClient); pet.fillColor.Set(clBkgText); pet.takesFocus.Set(TRUE);
			(* find a free place *)
			i := 0;
			WHILE (i < MaxNbrOfTabs) & (~found) DO
				IF pages[i] = NIL THEN pages[i] := pet; currentPageNr := i; found := TRUE; END;
				INC(i)
			END;
			UpdatePages;
		END NewTab;

		PROCEDURE GetNrFromPage(page : DbgPanel): LONGINT;
		VAR i : LONGINT; found : BOOLEAN;
		BEGIN
			i := 0; found := FALSE;
			WHILE (~found & (i < MaxNbrOfTabs)) DO
				IF (page = pages[i]) THEN RETURN i END;
				INC(i)
			END;
			RETURN -1
		END GetNrFromPage;
		
		PROCEDURE TabSelected(sender, data : ANY);
		VAR tab : WMTabComponents.Tab;
		BEGIN
			IF (data # NIL) & (data IS WMTabComponents.Tab) THEN
				DisableUpdate;
				page.RemoveContent(currentPage);
				tab := data(WMTabComponents.Tab);
				IF (tab.data # NIL) & (tab.data IS WMComponents.VisualComponent) THEN
					currentPage := tab.data(DbgPanel);
					currentPageNr := GetNrFromPage(currentPage);
					page.AddContent(currentPage);
					IF ~currentPage.initialized THEN currentPage.Initialize END;
					currentPage.Reset(SELF, NIL);
					page.AlignSubComponents;
				END;
				EnableUpdate;
(*				UpdateState;*)
				page.Invalidate
			END
		END TabSelected;
		
		PROCEDURE SelectTab(n:LONGINT);
		VAR tab : WMTabComponents.Tab;
		BEGIN
				DisableUpdate;
				page.RemoveContent(currentPage);
					
					currentPage := pages[n];
					currentPageNr := n;
					page.AddContent(currentPage);
					IF ~currentPage.initialized THEN currentPage.Initialize END;
					currentPage.Reset(SELF, NIL);
					page.AlignSubComponents;
				EnableUpdate;
(*				UpdateState;*)
				page.Invalidate;
				UpdatePages;
		END SelectTab;

		PROCEDURE UpdatePages;
		VAR i : LONGINT;
			tab : WMTabComponents.Tab;
			s : Strings.String;
			foundModifiedPage : BOOLEAN;
		BEGIN
			DisableUpdate;
			tabs.RemoveAllTabs;
			IF currentPage # NIL THEN page.RemoveContent(currentPage);
				currentPage := NIL
			END;
			IF currentPageNr >= 0 THEN currentPage := pages[currentPageNr] END;
			foundModifiedPage := FALSE;
			FOR i := 0 TO 99 DO
				tabList[i] := NIL;
				IF pages[i] # NIL THEN
					pages[i].alignment.Set(AlignClient);
					tab := tabs.NewTab();
					tabs.AddTab(tab);
					tabList[i] := tab;
					s := Strings.NewString(pages[i].filename);
					tabs.SetTabCaption(tab, s);
					tabs.SetTabData(tab, pages[i]);
				END
			END;
			IF currentPage = NIL THEN
				i := 0;
				WHILE (i < MaxNbrOfTabs) & (currentPage = NIL) DO
					IF pages[i] # NIL THEN currentPage := pages[i]; currentPageNr := i END;
					INC(i);
				END;
			END;
			IF currentPage # NIL THEN
				IF ~currentPage.initialized THEN currentPage.Initialize END;
				page.AddContent(currentPage);
				currentPage.Reset(SELF, NIL);
				page.AlignSubComponents;
				page.Invalidate;
				IF tabList[currentPageNr] # NIL THEN tabs.Select(tabList[currentPageNr]) END
			END;
			EnableUpdate;
		END UpdatePages;

		
	END Window;


PROCEDURE GetProcOffset(CONST name:ARRAY OF CHAR; VAR adr:ADDRESS);
VAR
	mn,pn:ARRAY 80 OF CHAR; (*TODO: fix to max name length!*)
	i,j:LONGINT;
BEGIN
	i:=0;j:=0;
	WHILE (name[i]#0X)&(name[i]#".") DO mn[i]:=name[i];INC(i) END;
	INC(i);
	WHILE (name[i]#0X) DO pn[j]:=name[i];INC(i);INC(j)  END;
	IF pn="@Body" THEN
		BtDTraps.GetProcedure(mn,"$$",adr);
	ELSE
		BtDTraps.GetProcedure(mn,pn,adr);
	END;
(*	KernelLog.String("module= "); KernelLog.String(mn); KernelLog.Ln;
	KernelLog.String("procedure= "); KernelLog.String(pn); KernelLog.Ln;*)
END GetProcOffset;
(*loading debug information the relationship position in the text and code from file, 
 and fixing addresses to the address of procedures  in memory  *)
PROCEDURE LoadModulePosInfo(CONST name:ARRAY OF CHAR; VAR m:ModuleInfo;CONST text:Texts.Text);
(*
name - name of file on disk
m - pointer to the module debug infomation
*)
		VAR
			file:Files.File;
			r: Files.Reader;
			pos,pc:LONGINT;
			count:LONGINT;
			ch:CHAR;
			offset:ADDRESS;
			res:BOOLEAN;
			buf:ARRAY 255 OF CHAR;
			curPI:ProcInfo;
			utilreader : Texts.TextReader;

			PROCEDURE SearchBegin((*CONST ucsStr: ARRAY OF Texts.Char32;*) from: LONGINT):LONGINT;
			BEGIN
					text.AcquireRead;
					RETURN TextUtilities.GenericPos(beginstrutf, from, text, FALSE, TRUE);
					text.ReleaseRead;
			END SearchBegin;
			(* Compare the pattern string of length 'length' with the string at the current position/direction of the text reader 'r' *)
			PROCEDURE Equals(CONST pattern : ARRAY OF Texts.Char32; length : LONGINT) : BOOLEAN;
			VAR ch, chp : Texts.Char32; equals : BOOLEAN; i : LONGINT;
			BEGIN
				i := 0; equals := TRUE;
				WHILE (i < length) DO
					utilreader.ReadCh(ch); chp := pattern[i];
					IF (ch # chp) THEN equals := FALSE; i := length; END; (* hash values are equal, but strings are not *)
					INC(i);
				END;
				RETURN equals;
			END Equals;
			
			PROCEDURE SearchEnd(VAR from: LONGINT;adr:ADDRESS):LONGINT;
			VAR
				pos:LONGINT;
				ch : Texts.Char32;
				idx:LONGINT;
				name,ext:ARRAY 80 OF CHAR;
				extf:ARRAY 80 OF LONGINT;
			BEGIN
					text.AcquireRead;
					from:=TextUtilities.GenericPos(endinstrutf, from, text, FALSE, FALSE);
					IF Trace THEN KernelLog.String(" pos end= "); KernelLog.Int(from,0); END;
					Files.SplitExtension(curPI.name,name,ext);
					idx:=0;UTF8Strings.UTF8toUnicode(ext, extf, idx);
					from:=TextUtilities.GenericPos(extf, from, text, FALSE, FALSE);
					IF Trace THEN KernelLog.String(" pos end+= "); KernelLog.Int(from,0); KernelLog.Ln; END;
					text.ReleaseRead;
					WHILE SYSTEM.GET32(adr)#0C35DEC89H DO INC(adr) END;(*Find first:	MOV	ESP, EBP; POP	EBP; RET*)
					RETURN adr;
			END SearchEnd;

		BEGIN
			NEW(utilreader, text);

			NEW(m);
			count:=0;curPI:=NIL;
			file := Files.Old (name);
			IF file = NIL THEN	KernelLog.String("Failed to open file ");KernelLog.String(name);KernelLog.Ln; RETURN; END;
			Files.OpenReader (r, file, 0);
			WHILE r.res = Files.Ok DO
				r.Char(ch);
				IF ch="m" THEN (*name of procedure marker*)
					IF curPI#NIL THEN (* *)
						curPI.lastOfs:=SearchEnd(pos,pc+offset);
						m.AddPos(curPI, pos, curPI.lastOfs);

					END;
					r.Ln(buf);
					GetProcOffset(buf,offset);
					curPI:=m.AddProc(buf);
					curPI.startOfs:=offset;
					IF offset=0 THEN
						KernelLog.String("NotFound: "); KernelLog.String(buf); KernelLog.Ln;
					END;
					winstance.combo.AddItem(Strings.NewString(buf),curPI);
				ELSIF ch="p" THEN(*position info marker*)
					r.SkipSpaces;r.Int(pos,FALSE);r.SkipSpaces;r.Int(pc,TRUE);r.Ln(buf);
					IF pc=0 THEN
						pos:=SearchBegin(pos);
					END;
					m.AddPos(curPI, pos, pc+offset);
				ELSIF ch=0X THEN
				ELSE
					HALT(18);(*panic, file unknow format*)
				END;
			END;
(*TODO: add info about @Body
			IF curPI#NIL THEN (* *)
			curPI.lastOfs:=pc+offset;
			END;
*)
			m.Sort;
			m.mod := Modules.ThisModuleByAdr(pc+offset);

(*						KernelLog.String("######################### "); KernelLog.Ln;
			m.DumpPos();
						KernelLog.String("######################### "); KernelLog.Ln;*)
END LoadModulePosInfo;


VAR
	winstance : Window;

(** Open document *)
PROCEDURE Open*(context : Commands.Context); (** [Options] {filename['@'position]} ~ *)
VAR
 count, index, temp, position : LONGINT;
	filename : Filename; format : ARRAY 32 OF CHAR;
BEGIN
	IF winstance=NIL THEN NEW(winstance); END;
	count := 0;
	WHILE context.arg.GetString(filename) DO
		Strings.Trim(filename,' ');
		KernelLog.String("filename= "); KernelLog.String(filename);  KernelLog.Ln;
		IF  filename # "" THEN winstance.Load(filename);  INC(count) END
	END;
	IF count = 0 THEN Cleanup() END;
	BtDTraps.InstallDbgHandler(winstance.DbgHandler);
END Open;


PROCEDURE Cleanup;
BEGIN
	IF winstance # NIL THEN winstance.Close END;
	BtDTraps.RemoveDbgHandler();
END Cleanup;

PROCEDURE LoadModule(CONST moduleName : ARRAY OF CHAR);
VAR module : Modules.Module; msg : ARRAY 128 OF CHAR; res : LONGINT;
BEGIN
	module := Modules.ThisModule(moduleName, res, msg);
END LoadModule;


VAR
	idx:LONGINT;
	StrDbgPanel:Strings.String;
	compiler : CompilerInterface.Compiler;
	diagnostics : WMDiagnostics.Model;
BEGIN
	NEW(diagnostics);
	compiler:=CompilerInterface.GetCompilerByName("Fox");
	IF (compiler = NIL) THEN
		LoadModule("TextCompiler"); (* compiler shall register itself at the CompilerInterface *)
		compiler := CompilerInterface.GetCompilerByName("Fox");
	END;
	IF (compiler = NIL) THEN
		KernelLog.String("No compiler available!"); KernelLog.Ln;
	END;
	Modules.InstallTermHandler (Cleanup);
	StrDbgPanel := Strings.NewString("DbgPanel");
	beginstr:="BEGIN";
	endinstr:="END";
	idx:=0;UTF8Strings.UTF8toUnicode(beginstr, beginstrutf, idx);
	idx:=0;UTF8Strings.UTF8toUnicode(endinstr, endinstrutf, idx);
	(* Additional BEGIN processing. *)
END WMDebugger.~

WMDebugger.Test;

CompilerInterface.Show~


WMDebugger.Open WMDebugger/WMComboBox.Mod~
PET.Open WMDebugger/TestDbg.Mod~

WMDebugger/WMTextView2.Mod WMDebugger/BtMenus.Mod~


SystemTools.Free WMDebugger BtMenus BtDTraps BtDbgPanel WMComboBox TestDbg~
Loader2.Trace~
TestDbg.TestLng~
WMDebugger.Window.GetLocalVars.WriteProc0:243

WMDebugger.Open Decoder.Mod WMDebugger/TestDbg.Mod~
Decoder.Open TestDbg.Obw~
WMDebugger.Open WMDebugger/TestDbg.Mod~